<template></template>

<script>
    export default {

        props: {
            classname: {
                type: String,
                required: true,
            },

            entityId: {
                type: Number,
                required: true,
            },

            fieldname: {
                type: String,
                required: true,
            },

            oldValue: {
                default: null,
            },

            newValue: {
                default: null,
            },

            disabled: {
                type: Boolean,
                default: false,
            },

            type: {
                type: String,
                required: true,
            },

            isChanging: {
                type: Boolean,
                default: false,
            }
        },

        methods: {
            changeValue() {
                axios.post('/api/v1/brojectcode/databasefieldchanger/change', {
                    classname: this.classname,
                    entityId: this.entityId,
                    fieldname: this.fieldname,
                    oldValue: this.oldValue,
                    newValue: this.newValue,
                    type: this.type,
                    disabled: this.disabled,
                })
                    .then(response => {
                        this.$emit('changeSucceeded', response.data);
                    })
                    .catch(error => {
                        this.$emit('changeFailed', error.response.data);
                    });
            }
        },

        watch: {
            isChanging: function (boolean) {
                if (boolean && !this.disabled) {
                    this.changeValue();
                }
            }  
        }

    }
</script>
